﻿Imports System.Runtime.InteropServices
Imports System.IO
Imports System.Text
Public Class Form1

    Public Class VolumeMixer
        Public Shared Function GetApplicationVolume(ByVal pid As Integer) As Single?
            Dim volume As ISimpleAudioVolume = GetVolumeObject(pid)
            If volume Is Nothing Then Return Nothing
            Dim level As Single
            volume.GetMasterVolume(level)
            Marshal.ReleaseComObject(volume)
            Return level * 100
        End Function
        Public Shared Function GetApplicationMute(ByVal pid As Integer) As Boolean?
            Dim volume As ISimpleAudioVolume = GetVolumeObject(pid)
            If volume Is Nothing Then Return Nothing
            Dim mute As Boolean
            volume.GetMute(mute)
            Marshal.ReleaseComObject(volume)
            Return mute
        End Function
        Public Shared Sub SetApplicationVolume(ByVal pid As Integer, ByVal level As Single)
            Dim volume As ISimpleAudioVolume = GetVolumeObject(pid)
            If volume Is Nothing Then Return
            Dim guid As Guid = Guid.Empty
            volume.SetMasterVolume(level / 100, guid)
            Marshal.ReleaseComObject(volume)
        End Sub
        Public Shared Sub SetApplicationMute(ByVal pid As Integer, ByVal mute As Boolean)
            Dim volume As ISimpleAudioVolume = GetVolumeObject(pid)
            If volume Is Nothing Then Return
            Dim guid As Guid = Guid.Empty
            volume.SetMute(mute, guid)
            Marshal.ReleaseComObject(volume)
        End Sub
        Private Shared Function GetVolumeObject(ByVal pid As Integer) As ISimpleAudioVolume
            Dim deviceEnumerator As IMMDeviceEnumerator = CType((New MMDeviceEnumerator()), IMMDeviceEnumerator)
            Dim speakers As IMMDevice
            deviceEnumerator.GetDefaultAudioEndpoint(EDataFlow.eRender, ERole.eMultimedia, speakers)
            Dim IID_IAudioSessionManager2 As Guid = GetType(IAudioSessionManager2).GUID
            Dim o As Object
            speakers.Activate(IID_IAudioSessionManager2, 0, IntPtr.Zero, o)
            Dim mgr As IAudioSessionManager2 = CType(o, IAudioSessionManager2)
            Dim sessionEnumerator As IAudioSessionEnumerator
            mgr.GetSessionEnumerator(sessionEnumerator)
            Dim count As Integer
            sessionEnumerator.GetCount(count)
            Dim volumeControl As ISimpleAudioVolume = Nothing
            For i As Integer = 0 To count - 1
                Dim ctl As IAudioSessionControl2
                sessionEnumerator.GetSession(i, ctl)
                Dim cpid As Integer
                ctl.GetProcessId(cpid)
                If cpid = pid Then
                    volumeControl = TryCast(ctl, ISimpleAudioVolume)
                    Exit For
                End If
                Marshal.ReleaseComObject(ctl)
            Next
            Marshal.ReleaseComObject(sessionEnumerator)
            Marshal.ReleaseComObject(mgr)
            Marshal.ReleaseComObject(speakers)
            Marshal.ReleaseComObject(deviceEnumerator)
            Return volumeControl
        End Function
    End Class
    <ComImport>
    <Guid("BCDE0395-E52F-467C-8E3D-C4579291692E")>
    Friend Class MMDeviceEnumerator
    End Class
    Friend Enum EDataFlow
        eRender
        eCapture
        eAll
        EDataFlow_enum_count
    End Enum
    Friend Enum ERole
        eConsole
        eMultimedia
        eCommunications
        ERole_enum_count
    End Enum
    <Guid("A95664D2-9614-4F35-A746-DE8DB63617E6"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Friend Interface IMMDeviceEnumerator
        Function NotImpl1() As Integer
        <PreserveSig>
        Function GetDefaultAudioEndpoint(ByVal dataFlow As EDataFlow, ByVal role As ERole, <Out> ByRef ppDevice As IMMDevice) As Integer
    End Interface
    <Guid("D666063F-1587-4E43-81F1-B948E807363F"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Friend Interface IMMDevice
        <PreserveSig>
        Function Activate(ByRef iid As Guid, ByVal dwClsCtx As Integer, ByVal pActivationParams As IntPtr, <Out>
        <MarshalAs(UnmanagedType.IUnknown)> ByRef ppInterface As Object) As Integer
    End Interface
    <Guid("77AA99A0-1BD6-484F-8BC7-2C654C9A9B6F"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Friend Interface IAudioSessionManager2
        Function NotImpl1() As Integer
        Function NotImpl2() As Integer
        <PreserveSig>
        Function GetSessionEnumerator(<Out> ByRef SessionEnum As IAudioSessionEnumerator) As Integer
    End Interface
    <Guid("E2F5BB11-0570-40CA-ACDD-3AA01277DEE8"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Friend Interface IAudioSessionEnumerator
        <PreserveSig>
        Function GetCount(<Out> ByRef SessionCount As Integer) As Integer
        <PreserveSig>
        Function GetSession(ByVal SessionCount As Integer, <Out> ByRef Session As IAudioSessionControl2) As Integer
    End Interface
    <Guid("87CE5498-68D6-44E5-9215-6DA47EF883D8"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Friend Interface ISimpleAudioVolume
        <PreserveSig>
        Function SetMasterVolume(ByVal fLevel As Single, ByRef EventContext As Guid) As Integer
        <PreserveSig>
        Function GetMasterVolume(<Out> ByRef pfLevel As Single) As Integer
        <PreserveSig>
        Function SetMute(ByVal bMute As Boolean, ByRef EventContext As Guid) As Integer
        <PreserveSig>
        Function GetMute(<Out> ByRef pbMute As Boolean) As Integer
    End Interface
    <Guid("bfb7ff88-7239-4fc9-8fa2-07c950be9c6d"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    Friend Interface IAudioSessionControl2
        <PreserveSig>
        Function NotImpl0() As Integer
        <PreserveSig>
        Function GetDisplayName(<Out>
        <MarshalAs(UnmanagedType.LPWStr)> ByRef pRetVal As String) As Integer
        <PreserveSig>
        Function SetDisplayName(
        <MarshalAs(UnmanagedType.LPWStr)> ByVal Value As String,
        <MarshalAs(UnmanagedType.LPStruct)> ByVal EventContext As Guid) As Integer
        <PreserveSig>
        Function GetIconPath(<Out>
        <MarshalAs(UnmanagedType.LPWStr)> ByRef pRetVal As String) As Integer
        <PreserveSig>
        Function SetIconPath(
        <MarshalAs(UnmanagedType.LPWStr)> ByVal Value As String,
        <MarshalAs(UnmanagedType.LPStruct)> ByVal EventContext As Guid) As Integer
        <PreserveSig>
        Function GetGroupingParam(<Out> ByRef pRetVal As Guid) As Integer
        <PreserveSig>
        Function SetGroupingParam(
        <MarshalAs(UnmanagedType.LPStruct)> ByVal Override As Guid,
        <MarshalAs(UnmanagedType.LPStruct)> ByVal EventContext As Guid) As Integer
        <PreserveSig>
        Function NotImpl1() As Integer
        <PreserveSig>
        Function NotImpl2() As Integer
        <PreserveSig>
        Function GetSessionIdentifier(<Out>
        <MarshalAs(UnmanagedType.LPWStr)> ByRef pRetVal As String) As Integer
        <PreserveSig>
        Function GetSessionInstanceIdentifier(<Out>
        <MarshalAs(UnmanagedType.LPWStr)> ByRef pRetVal As String) As Integer
        <PreserveSig>
        Function GetProcessId(<Out> ByRef pRetVal As Integer) As Integer
        <PreserveSig>
        Function IsSystemSoundsSession() As Integer
        <PreserveSig>
        Function SetDuckingPreference(ByVal optOut As Boolean) As Integer
    End Interface
    Private IsFormBeingDragged As Boolean = False
    Private MouseDownX As Integer
    Private MouseDownY As Integer

    Public Linked As Integer = 0
    Public FocusMode As Integer = 0

    Public DiscordFocusVolumeDiscord As Single = 70.0F
    Public DiscordFocusVolumeYoutube As Single = 5.0F
    Public YoutubeFocusVolumeDiscord As Single = 5.0F
    Public YoutubeFocusVolumeYoutube As Single = 70.0F

    Private Sub Grabbable_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs) Handles Me.MouseDown, Label2.MouseDown, Label6.MouseDown, Label7.MouseDown, Label8.MouseDown, Panel1.MouseDown

        If e.Button = MouseButtons.Left Then
            IsFormBeingDragged = True
            MouseDownX = e.X
            MouseDownY = e.Y
        End If
    End Sub

    Private Sub Grabbable_MouseUp(ByVal sender As Object, ByVal e As MouseEventArgs) Handles Me.MouseUp, Label2.MouseUp, Label6.MouseUp, Label7.MouseUp, Label8.MouseUp, Panel1.MouseUp

        If e.Button = MouseButtons.Left Then
            IsFormBeingDragged = False
        End If
    End Sub

    Private Sub Grabbable_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs) Handles Me.MouseMove, Label2.MouseMove, Label6.MouseMove, Label7.MouseMove, Label8.MouseMove, Panel1.MouseMove

        If IsFormBeingDragged Then
            Dim temp As Point = New Point()

            temp.X = Me.Location.X + (e.X - MouseDownX)
            temp.Y = Me.Location.Y + (e.Y - MouseDownY)
            Me.Location = temp
            temp = Nothing
        End If
    End Sub
    Private Sub SetApplicationSound(processName As String, volume As Single)
        Dim p() As Process = Process.GetProcessesByName(processName)
        If p.Count > 0 Then
            For Each proc In p
                Dim pID As Integer = proc.Id
                If pID = 0 Then Return
                VolumeMixer.SetApplicationVolume(pID, volume)
            Next
        End If
    End Sub

    Private Sub CloseBtn_MouseEnter(sender As Object, e As EventArgs) Handles CloseBtn.MouseEnter
        CloseBtn.BackColor = Color.Red
    End Sub

    Private Sub CloseBtn_MouseLeave(sender As Object, e As EventArgs) Handles CloseBtn.MouseLeave
        CloseBtn.BackColor = Color.FromArgb(25, 25, 25)
    End Sub
    Private Sub CloseBtn_Click(sender As Object, e As EventArgs) Handles CloseBtn.Click
        Me.Hide()
    End Sub
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        'My.Settings.DiscordFocusVolumeDiscord = DiscordFocusVolumeDiscord
        'My.Settings.DiscordFocusVolumeYoutube = DiscordFocusVolumeYoutube
        'My.Settings.YoutubeFocusVolumeDiscord = YoutubeFocusVolumeDiscord
        'My.Settings.YoutubeFocusVolumeYoutube = YoutubeFocusVolumeYoutube

        'My.Settings.Save()
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        VolumeChange()
        'DiscordFocusVolumeDiscord = My.Settings.DiscordFocusVolumeDiscord
        'DiscordFocusVolumeYoutube = My.Settings.DiscordFocusVolumeYoutube
        'YoutubeFocusVolumeDiscord = My.Settings.YoutubeFocusVolumeDiscord
        'YoutubeFocusVolumeYoutube = My.Settings.YoutubeFocusVolumeYoutube
        VersionTxt()
    End Sub

    Public path As String = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) & "\version.txt"
    Sub VersionTxt()

        ' Create or overwrite the file.
        Dim fs As FileStream = File.Create(path)

        ' Add text to the file.
        Dim info As Byte() = New UTF8Encoding(True).GetBytes(Application.ProductVersion)
        fs.Write(info, 0, info.Length)
        fs.Close()
    End Sub

    'DISCORD
    Dim VolumeDiscord As Single = 50.0F
    Private Sub VolumeProgramm1_Scroll(sender As Object, e As EventArgs) Handles VolumeProgramm1.Scroll
        VolumeDiscord = VolumeProgramm1.Value
        SetApplicationSound("discord", VolumeDiscord)

        If FocusMode = 1 Then
            FocusDiscord.BackColor = Color.Silver
            FocusYT.BackColor = Color.Silver

            FocusMode = 0
        End If

        If Linked = 1 Then
            VolumeProgramm2.Value = VolumeProgramm1.Value
            VolumeChrome = VolumeProgramm2.Value
            SetApplicationSound("chrome", VolumeChrome)
        End If

    End Sub

    'YOUTUBE
    Dim VolumeChrome As Single = 50.0F
    Private Sub VolumeProgramm2_Scroll(sender As Object, e As EventArgs) Handles VolumeProgramm2.Scroll
        VolumeChrome = VolumeProgramm2.Value
        SetApplicationSound("chrome", VolumeChrome)

        If FocusMode = 1 Then
            FocusDiscord.BackColor = Color.Silver
            FocusYT.BackColor = Color.Silver

            FocusMode = 0
        End If

        If Linked = 1 Then
            VolumeProgramm1.Value = VolumeProgramm2.Value
            VolumeDiscord = VolumeProgramm1.Value
            SetApplicationSound("discord", VolumeDiscord)
        End If
    End Sub

    Public p() As Process
    Public p1() As Process

    Public pstatus As Integer
    Public p1status As Integer

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        CheckIfRunning()

        If pstatus = 1 Then
            VolumeLabel1.ForeColor = Color.White
            ProgrammLabel1.ForeColor = Color.White
            VolumeProgramm1.Enabled = True
        Else
            VolumeLabel1.ForeColor = Color.DarkGray
            ProgrammLabel1.ForeColor = Color.Red
            VolumeProgramm1.Enabled = False
        End If

        If p1status = 1 Then
            VolumeLabel2.ForeColor = Color.White
            ProgrammLabel2.ForeColor = Color.White
            VolumeProgramm2.Enabled = True
        Else
            VolumeLabel2.ForeColor = Color.DarkGray
            ProgrammLabel2.ForeColor = Color.Red
            VolumeProgramm2.Enabled = False
        End If

        VolumeLabel1.Text = VolumeDiscord & " %"
        VolumeLabel2.Text = VolumeChrome & " %"

        'DISCORD RED FORECOLOR
        If VolumeLabel1.Text = "0 %" Then
            VolumeLabel1.ForeColor = Color.Red
            ProgrammLabel1.ForeColor = Color.Red
        Else

        End If

        'YOUTUBE RED FORECOLOR
        If VolumeLabel2.Text = "0 %" Then
            VolumeLabel2.ForeColor = Color.Red
            ProgrammLabel2.ForeColor = Color.Red
        Else

        End If

    End Sub

    Private Sub CheckIfRunning()
        p = Process.GetProcessesByName("discord")
        If p.Count > 0 Then
            pstatus = 1
        Else
            pstatus = 0
        End If

        p1 = Process.GetProcessesByName("chrome")
        If p1.Count > 0 Then
            p1status = 1
        Else
            p1status = 0
        End If
    End Sub

    'DISCORD ICON/BUTTON
    Private Sub PBDiscord_Click(sender As Object, e As EventArgs) Handles PBDiscord.Click

        If CBDiscord.Checked = True Then
            CBDiscord.Checked = False
            UnMuteDiscord()
        Else
            CBDiscord.Checked = True
            MuteDiscord()
        End If

    End Sub

    'YOUTUBE ICON/BUTTON
    Private Sub PBYT_Click(sender As Object, e As EventArgs) Handles PBYT.Click

        If CBYT.Checked = True Then
            CBYT.Checked = False
            UnMuteYT()
        Else
            CBYT.Checked = True
            MuteYT()
        End If
    End Sub

    'DISCORD MUTE/UNMUTE
    Dim OldVolumeDiscord As Single = 0.0F
    Sub MuteDiscord()

        OldVolumeDiscord = VolumeDiscord

        VolumeProgramm1.Value = 0
        VolumeDiscord = 0.0F
        SetApplicationSound("discord", VolumeDiscord)

    End Sub
    Sub UnMuteDiscord()
        VolumeDiscord = OldVolumeDiscord
        VolumeChange()

    End Sub

    'YOUTUBE MUTE/UNMUTE
    Dim OldVolumeYT As Single = 0.0F
    Sub MuteYT()

        OldVolumeYT = VolumeChrome

        VolumeProgramm2.Value = 0
        VolumeChrome = 0.0F
        SetApplicationSound("chrome", VolumeChrome)

        'PBYT.Image = My.Resources.youtube_brands_r
    End Sub

    Sub UnMuteYT()
        VolumeChrome = OldVolumeYT
        VolumeChange()

        'PBYT.Image = My.Resources.youtube_brands_g
    End Sub

    'LINK BUTTON
    Private Sub LinkBtn_Click(sender As Object, e As EventArgs) Handles LinkBtn.Click
        If Linked = 0 Then
            Linked = 1
            'LinkBtn.Image = My.Resources.link_solid_lb
        Else
            Linked = 0
            'LinkBtn.Image = My.Resources.link_solid_g
        End If
    End Sub

    Private Sub LinkBtn_MouseEnter(sender As Object, e As EventArgs) Handles LinkBtn.MouseEnter

        If Linked = 1 Then
            'LinkBtn.Image = My.Resources.link_solid_lb
        Else
            'LinkBtn.Image = My.Resources.link_solid_g
        End If
    End Sub

    Private Sub LinkBtn_MouseLeave(sender As Object, e As EventArgs) Handles LinkBtn.MouseLeave

        If Linked = 1 Then
            'LinkBtn.Image = My.Resources.link_solid_blue
        Else
            'LinkBtn.Image = My.Resources.link_solid_w
        End If
    End Sub

    'FOCUSMODE 
    Private Sub FocusDiscord_Click(sender As Object, e As EventArgs) Handles FocusDiscord.Click

        FocusMode = 1

        'PBDiscord.Image = My.Resources.discord_brands_g
        'PBYT.Image = My.Resources.youtube_brands_g

        FocusDiscord.BackColor = Color.Green
        FocusYT.BackColor = Color.Red

        VolumeDiscord = DiscordFocusVolumeDiscord
        VolumeChrome = DiscordFocusVolumeYoutube

        VolumeChange()
    End Sub

    Private Sub FocusYT_Click(sender As Object, e As EventArgs) Handles FocusYT.Click

        FocusMode = 1

        'PBDiscord.Image = My.Resources.discord_brands_g
        'PBYT.Image = My.Resources.youtube_brands_g

        FocusDiscord.BackColor = Color.Red
        FocusYT.BackColor = Color.Green

        VolumeDiscord = YoutubeFocusVolumeDiscord
        VolumeChrome = YoutubeFocusVolumeYoutube

        VolumeChange()
    End Sub

    Sub VolumeChange()

        VolumeLabel1.Text = VolumeDiscord
        VolumeLabel2.Text = VolumeChrome

        VolumeProgramm1.Value = VolumeDiscord
        VolumeProgramm2.Value = VolumeChrome

        SetApplicationSound("discord", VolumeDiscord)
        SetApplicationSound("chrome", VolumeChrome)

    End Sub

    Private Sub Label3_MouseEnter(sender As Object, e As EventArgs) Handles Label3.MouseEnter
        Label3.BackColor = Color.FromArgb(8, 124, 220)
    End Sub
    Private Sub Label3_MouseLeave(sender As Object, e As EventArgs) Handles Label3.MouseLeave
        Label3.BackColor = Color.FromArgb(25, 25, 25)
    End Sub

    Private Sub Label3_Click(sender As Object, e As EventArgs) Handles Label3.Click
        Form4.Show()
    End Sub

    Private Declare Function GetKeyPress Lib "user32" Alias "GetAsyncKeyState" (ByVal key As Integer) As Integer

    Private Sub Timer2_Tick(sender As Object, e As EventArgs) Handles Timer2.Tick

        If GetKeyPress(Form4.Hotkey1) Then
            FocusMode = 1

            'PBDiscord.Image = My.Resources.discord_brands_g
            'PBYT.Image = My.Resources.youtube_brands_g

            FocusDiscord.BackColor = Color.Green
            FocusYT.BackColor = Color.Red

            VolumeDiscord = DiscordFocusVolumeDiscord
            VolumeChrome = DiscordFocusVolumeYoutube

            Console.Beep("1000", "100")

            Form3.Show()
            Form3.Label1.Text = "[FOCUS MODE]: DISCORD"
            Form3.ProgressBar1.Value = 0
            Timer1.Start()

            VolumeChange()

        ElseIf GetKeyPress(Form4.Hotkey2) Then

            FocusMode = 0
            VolumeDiscord = 50.0F
            VolumeChrome = 50.0F

            FocusDiscord.BackColor = Color.Silver
            FocusYT.BackColor = Color.Silver

            Console.Beep("800", "100")

            Form3.Show()
            Form3.Label1.Text = "[FOCUS MODE]: OFF"
            Form3.ProgressBar1.Value = 0
            Timer1.Start()

            VolumeChange()

        ElseIf GetKeyPress(Form4.Hotkey3) Then
            FocusMode = 1

            'PBDiscord.Image = My.Resources.discord_brands_g
            'PBYT.Image = My.Resources.youtube_brands_g

            FocusDiscord.BackColor = Color.Red
            FocusYT.BackColor = Color.Green

            VolumeDiscord = YoutubeFocusVolumeDiscord
            VolumeChrome = YoutubeFocusVolumeYoutube

            Console.Beep("600", "100")

            Form3.Show()
            Form3.Label1.Text = "[FOCUS MODE]: YOUTUBE"
            Form3.ProgressBar1.Value = 0
            Timer1.Start()

            VolumeChange()
        End If
    End Sub

    Private Sub NotifyIcon1_MouseClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon1.MouseClick
        Me.Show()
        Me.WindowState = FormWindowState.Normal
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs)
        Form3.Show()
    End Sub

    Private Sub Timer3_Tick(sender As Object, e As EventArgs) Handles Timer3.Tick
        Me.Hide()
        Timer3.Stop()
    End Sub

    Private Sub Label2_Click(sender As Object, e As EventArgs) Handles Label2.Click

    End Sub

    Private Sub Form1_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        If e.Control And e.Shift And e.KeyCode = Keys.D Then
            Form5.Show()
        End If
    End Sub

End Class
